//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  WH_CALLWNDPROCRETtbN֐̃eXgpvO
//  WH_CALLWNDPROCRET́CSẴbZ[WtbNł킯ł͂Ȃ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2008N1221 `
//  2015N0310
//    EWM_USERWM_APPɕύX
//    EWindows 7 + Delphi XEœ\ȃR[hɏC
//    EUIPIΉR[hǉ
//    ER[h
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, ExtCtrls;

type
 TForm1 = class(TForm)
    Panel1: TPanel;
    btnStart: TButton;
    btnStop: TButton;
    btnClear: TSpeedButton;
    Panel2: TPanel;
    ComboBox1: TComboBox;
    ListView1: TListView;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure ComboBox1CloseUp(Sender: TObject);
 protected
   procedure DisplayMessageInfo(AClass, ATitle: String; wParam: Cardinal);
   function GetWindowTitleStr(hWindow: HWND): String;
   function GetWindowClassNameStr(hWindow: HWND):string;
 private
    hHookLib : THANDLE;
    procedure WMAPPMessage(var Msg: TMessage); message WM_APP+220;
 public
 end;

var
 Form1: TForm1;

implementation

{$R *.DFM}

  // DLĽďo֐
  function StartWndProcHook(Wnd: HWND; AMsg: Integer): Boolean; stdcall;
    external 'PLHOOKWNDPROCRETMSG.DLL';
  procedure StopWndProcHook; stdcall; external 'PLHOOKWNDPROCRETMSG.DLL';

      
//=============================================================================
//  tH[̏
//  \[XWM_XXX̃XgoăR|{bNXɃZbg
//  EBhEbZ[WXg̃\[Xt@CMessageList.txt
//  ZbĝWM_XXX̕Ƃ̐l
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
const
  MSGFLT_ADD    = 1;
  MSGFLT_REMOVE = 2;
var
  DLLHandle  : THandle;
  FuncFilter : function (msg: Cardinal; dwFlag: DWORD): BOOL; stdcall;
  LResource  : TResourceStream;
  LList      : TStringList;
  i          : Integer;
  LText1     : String;
  LText2     : String;
  LPos       : Integer;
  LStyle     : Integer;
begin
  //UIPI([U[C^[tFCX̕)Ή
  //̃vOǗҌŎsĂbZ[W̎M\ɂ
  if CheckWin32Version(6, 0) then begin
    DLLHandle := loadLibrary('user32.dll');
    try
      if DLLHandle > 0 then begin
        @FuncFilter := GetProcAddress(DLLHandle, 'ChangeWindowMessageFilter');
        if @FuncFilter <> nil then begin
          FuncFilter(WM_APP + 220, MSGFLT_ADD);
        end;
      end;
    finally
      FreeLibrary(DLLHandle);
    end;
  end;

  Caption := 'WH_CALLWNDPROCRET eXg';

  LResource := TResourceStream.Create(hInstance, 'MessageList', 'TEXT');
  LList := TStringList.Create;
  ComboBox1.Items.Clear;
  try
    LList.LoadFromStream(LResource);
    for i := 0 to LList.Count - 1 do begin
      LPos := Pos('=', LList[i]);
      LText1 := Trim(Copy(LList[i], 1, LPos - 1));
      LText2 := Trim(Copy(LList[i], LPos + 1, Length(LList[i])));
      ComboBox1.Items.AddObject(LText1, TObject(StrToInt(LText2)));
    end;
  finally
    FreeAndNil(LResource);
    FreeAndNil(LList);
  end;

  //XN[o[ŏ\
  LStyle := GetWindowLong(ListView1.Handle, GWL_STYLE);
  ShowScrollBar(ListView1.Handle, SB_VERT, True);
  SetWindowLong(ListView1.Handle, GWL_STYLE, LStyle);
end;

//=============================================================================
//  tH[j̏
//  tbN
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if hHookLib <> 0 then begin
     StopWndProcHook;
     FreeLibrary(hHookLib);
     hHookLib := 0;

     btnStart.Enabled := True;
     btnStop.Enabled  := False;
  end;
end;

//=============================================================================
//  tbNLɂ
//  tbNJn֐́C̃tH[̃nhƁCtbN郁bZ[W̒l
//=============================================================================
procedure TForm1.btnStartClick(Sender: TObject);
var
  LIndex  : Integer;
  LRevMsg : Integer;
begin
  if ComboBox1.ItemIndex < 0 then exit;

  if hHookLib = 0 then begin
    LIndex   := ComboBox1.ItemIndex;
    LRevMsg  := Integer(ComboBox1.Items.Objects[LIndex]);
    hHookLib := LoadLibrary('PLHOOKWNDPROCRETMSG.DLL');
    StartWndProcHook(Handle, LRevMsg);

    btnStart.Enabled := False;
    btnStop.Enabled  := True;
  end;
end;

//=============================================================================
//  tbN𖳌ɂ
//=============================================================================
procedure TForm1.btnStopClick(Sender: TObject);
begin
  FormDestroy(nil);
end;

//=============================================================================
//  ListView̃ACeNA
//=============================================================================
procedure TForm1.btnClearClick(Sender: TObject);
begin
  ListView1.Items.Clear;
  ListView1.Update;
end;

//=============================================================================
//  R{{bNXŃtbNΏۃbZ[WύXxtbN~߂
//=============================================================================
procedure TForm1.ComboBox1CloseUp(Sender: TObject);
begin
  btnStopClick(nil);
end;

//-----------------------------------------------------------------------------
//  DLL̃bZ[W
//
//  DLLňȉ̒lZbgĂ
//  Msg.wParam bZ[WEBhẼnhl
//  Msg.lParam bZ[WŗL̒l(wParaml)
//-----------------------------------------------------------------------------
procedure TForm1.WMAPPMessage(var Msg: TMessage);
var
  LTargetWnd : HWND;
  LClass     : String;
  LTitle     : String;
  LwParam    : Cardinal;
begin
  if Msg.Msg = WM_APP + 220 then begin
    LTargetWnd := Msg.wParam;
    LClass     := GetWindowClassNameStr(LTargetWnd);
    LTitle     := GetWindowTitleStr(LTargetWnd);
    LwParam    := Msg.LParam;
    DisplayMessageInfo(LClass, LTitle, LwParam);
  end;
end;

//-----------------------------------------------------------------------------
//  ListViewɃtbNEChẼNXƃ^CgCwParaml\
//  wParamĺCʃ[hƏʃ[hlɕ16iŕ\
//-----------------------------------------------------------------------------
procedure TForm1.DisplayMessageInfo(AClass,ATitle: String; wParam: Cardinal);
var
  LItem : TListItem;
  LLow  : WORD;
  LHi   : WORD;
begin
  LLow := LOWORD(wParam);
  LHi  := HIWORD(wParam);

  LItem := ListView1.Items.Add;
  LItem.Caption := AClass;
  LItem.SubItems.Add (ATitle);
  LItem.SubItems.Add (Format('$%.4x ', [LHi]));
  LItem.SubItems.Add (Format('$%.4x ', [LLow]));

  //ListVieẅԍŌ\
  //ł͎ۂɂMakeVisibleOK
  ListView1.Items[ListView1.Items.Count - 1].Selected := True;
  ListView1.Items[ListView1.Items.Count - 1].Focused  := True;
  ListView1.Items[ListView1.Items.Count - 1].MakeVisible(True);
end;

//-----------------------------------------------------------------------------
//  EBhEnhEBhẼNX擾
//-----------------------------------------------------------------------------
function TForm1.GetWindowClassNameStr(hWindow: HWND): string;
var
  Buffer : array[0..MAX_PATH-1] of Char;
  Len    : Integer;
begin
  FillChar(Buffer, SizeOf(Buffer), #0);
  Len := GetClassName(hWindow, Buffer, Length(Buffer));
  if Len > 0 then Result := Buffer else Result := '';
end;

//-----------------------------------------------------------------------------
//  EBhEnhEBhẼ^Cg擾
//-----------------------------------------------------------------------------
function TForm1.GetWindowTitleStr(hWindow: HWND): String;
var
  Buffer : array[0..MAX_PATH-1] of Char;
  Len    : Integer;
begin
  FillChar(Buffer, SizeOf(Buffer), #0);
  Len := GetWindowText(hWindow, Buffer, Length(Buffer));
  if Len > 0 then Result := Buffer else Result := '';
end;

end.


